PrefabFiles = {
	"wayland",
	"terrorbeakpet",
	
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/wayland.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/wayland.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/wayland.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wayland.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/wayland_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wayland_silho.xml" ),

    Asset( "IMAGE", "bigportraits/wayland.tex" ),
    Asset( "ATLAS", "bigportraits/wayland.xml" ),
	
	Asset( "IMAGE", "images/map_icons/wayland.tex" ),
	Asset( "ATLAS", "images/map_icons/wayland.xml" ),
	
	
}

local require = GLOBAL.require
GetPlayer = GLOBAL.GetPlayer

GLOBAL.STRINGS.CHARACTER_TITLES.wayland = "The Possessed"
GLOBAL.STRINGS.CHARACTER_NAMES.wayland = "Wayland"
GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.wayland = "*Is possessed by a picky demon\n*Mr. Demon only allows consumption of monster food \n*Can't fight on his own"
GLOBAL.STRINGS.CHARACTER_QUOTES.wayland = "\"Mr. Demon keeps me safe.\""

GLOBAL.STRINGS.NAMES.TERRORBEAKPET= "Mr. Demon"
GLOBAL.STRINGS.CHARACTERS.WAYLAND = require "speech_wayland"

table.insert(GLOBAL.CHARACTER_GENDERS.MALE, "wayland")


AddMinimapAtlas("images/map_icons/wayland.xml")
AddModCharacter("wayland")

AddPrefabPostInit("flower_evil", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.pickable.onpickedfn = function(inst, picker)
			if picker and picker.components.sanity then
				picker.components.sanity:DoDelta(TUNING.SANITY_MED)
			end	
			inst:Remove()
		end
	    inst.components.sanityaura.aura = 0 -- To cancel the default sanity aura of evil flowers
	end
end)

AddPrefabPostInit("nightmarefuel", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst:AddComponent("edible")
	    inst.components.edible.healthvalue = 13
	    inst.components.edible.hungervalue = 13
	    inst.components.edible.sanityvalue = 13
	    inst.components.edible.foodtype = "MEAT"
	end
end)

local forbidden_foodset = {
	-- Raw Foods
	berries = true,
	butter = true,
	carrot = true, 
	cave_banana = true,
	corn = true,
	dragonfruit = true,
	drumstick = true,
	durian = true,
	eel = true,
	bird_egg = true,
	eggplant = true,
	fish = true,
	froglegs = true,
	trunk_summer = true,
	trunk_winter = true,
	meat = true,
	smallmeat = true,
	pomegranate = true,
	pumpkin = true,
	seeds = true,
	tallbirdegg = true,
	tallbirdegg_cracked = true,
	
	lightbulb = true,
	cutlichen = true,
	honey = true, 
	petals = true,
	rottenegg = true,
	
	-- Cooked Foods
	baconeggs = true,
	tallbirdegg_cooked = true,
	seeds_cooked = true,
	pumpkin_cooked = true,
	pomegranate_cooked = true,
	smallmeat_dried = true,
	cookedsmallmeat = true,
	meat_dried = true,
	cookedmeat = true,
	trunk_cooked = true,
	froglegs_cooked = true,
	fish_cooked = true,
	eggplant_cooked = true,
	bird_egg_cooked = true, 
	eel_cooked = true,
	durian_cooked = true, 
	drumstick_cooked = true,
	dragonfruit_cooked = true,
	popcorn = true,
	cave_banana_cooked = true,
	carrot_cooked = true,
	berries_cooked = true, 
	
	-- Meals
	butterflymuffin = true,
	dragonpie = true,
	fishtacos = true,
	fishsticks = true,
	jammypreserves = true,
	frogglebunwich = true,
	fruitmedley = true,
	honeyham = true,
	honeynuggets = true,
	kabobs = true,
	meatballs = true,
	bonestew = true,
	perogies = true,
	powcake = true,
	pumpkincookie = true,
	ratatouille = true,
	stuffedeggplant = true,
	taffy = true,
	turkeydinner = true,
	unagi = true,
	waffles = true,
	
	-- RoG
	goatmilk = true,
	cactus_meat = true,
	cactus_meat_cooked = true,
	cactus_flower = true,
	acorn = true,
	acorn_cooked = true,
	watermelon = true,
	watermelon_cooked = true,
	watermelonicle = true,
	guacamole = true,
	icecream = true,
	flowersalad = true,
	hotchili = true,
	trailmix = true,
}

function pickyeater(inst)
	if inst.prefab == "wayland" then
		inst.components.eater:SetCanEatTestFn(function(inst, food)
			return not food.prefab or not forbidden_foodset[food.prefab]
		end)
	end
end

AddSimPostInit(pickyeater)

AddPrefabPostInit("rabbit", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.2)
	end
end)
AddPrefabPostInit("crow", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("robin", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("robin_winter", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("perd", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.5)
	end
end)
AddPrefabPostInit("penguin", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.3)
	end
end)
AddPrefabPostInit("bee", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("killerbee", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("beefalo", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("babybeefalo", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("butterfly", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("bunnyman", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("koalefant_summer", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("koalefant_winter", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("pigman", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("pigguard", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("smallbird", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("teenbird", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("frog", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.2)
	end
end)
AddPrefabPostInit("walrus", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("little_walrus", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("krampus", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("ghost", function(inst)
	if GetPlayer().prefab == "wayland" then
		inst:AddComponent("lootdropper")
		inst.components.lootdropper:SetLoot({"nightmarefuel"})
	end
end)